; =========================
;;; ========== Le type abstrait "arbre d'expression" [MI2, 2001-2002]

(define arbre list)   ; ainsi arbre est d'arite variable...

(define (racine A)
  (if (feuille? A)
      (error "pas de racine pour une feuille :" A)
      (car A)))

(define (fg A)
  (if (feuille? A)
      (error "pas de fg pour une feuille :" A)
      (cadr A)))

(define (fd A)
  (if (feuille? A)
      (error "pas de fd pour une feuille :" A)
      (caddr A)))

(define (fdd A)
  (if (or (feuille? A) (not (equal? (racine A) 'if)))
      (error "pas de fdd :" A)
      (cadddr A)))

(define (feuille? x)
  (or (number? x)
      (boolean? x)
      (and (symbol? x) (not (operateur? x)))))

(define (operateur? x)
  (member x '(+ * - / < = > >= <=)))   ; if N'EST PAS un operateur !!!

; FIN ARBRE
; =========================

(define (jouer)
  (let ((solution '())
        (tirage '())
        (cpt '())
        (arret #f)
        )
    
    ; _____________________ LA FRAME _______________________
    
    
    (define (tirage-chiffres)
      (let ((elements #(1 2 3 4 5 6 7 8 9 10 1 2 3 4 5 6 7 8 9 10 25 50 75 100)))
        (do ((i 0 (+ i 1))(tirage '() (cons (let* ((indice (random (- (vector-length elements) i)))
                                                   (temp (vector-ref elements indice))
                                                   (fin (- (vector-length elements) i 1)))
                                              (vector-set! elements indice (vector-ref elements fin))
                                              (vector-set! elements fin temp)
                                              temp
                                              )
                                            tirage)))
          ((= i 6) tirage))
        ))
    
    (define (compte)
      (let ((c1 (+ 1 (random 9))) (c2 (random 10)) (c3 (random 10)))
        (list (list c1 c2 c3) (+ (* c1 100) (* c2 10) c3))))
    
    (define (afficher-chiffres L)
      (do ((i 1 (+ i 1))(abs 2 (+ abs 61 23))(L L (cdr L)))
        ((= 6 i) (send $bitmap-dc draw-bitmap
                       (make-object bitmap% (string-append (number->string (car L)) ".jpg")) abs 2))
        (send $bitmap-dc draw-bitmap
              (make-object bitmap% (string-append (number->string (car L)) ".jpg")) abs 2)
        (send $bitmap-dc draw-bitmap
              (make-object bitmap% "trait.jpg") (+ abs 61) 2)))
    
    (define (afficher-compte L abs)
      (if (not (null? L))
          (begin
            (send $bitmap-dc-compte draw-bitmap
                (make-object bitmap% (string-append (number->string (car L)) "c.jpg"))
                abs 2)
            (afficher-compte (cdr L) (+ abs 23)))))
    
    (define (effacer-chiffres)
      (send $bitmap-dc clear))
    
    (define (effacer-compte)
      (send $bitmap-dc-compte clear))
    
    (define $frame
      (make-object frame% "Le compte est bon" #f
        500
        300
        10
        10
        '(no-resize-border)))
    
    (define $barre-menu
      (make-object menu-bar% $frame))
    
    (define $menu-fichier
      (make-object menu% "Fichier" $barre-menu))
    
    
    ; le rapport du projet
    ; ======================
    ; reecriture de classe
    (define $editor-canvas%
     (class editor-canvas% (frame editor type)
      (inherit get-dc)
      (override
        (on-event
         (lambda (m)
           (void)))
        (on-char
         (lambda (k)
           (void))))
      (sequence (super-init frame editor type))))
    
    (define $dialog-projet
      (make-object dialog% "Le projet" $frame 560 400))

    (define $projet-text
      (make-object text%))

    (define $projet-edit
      (make-object $editor-canvas% $dialog-projet $projet-text '(no-hscroll)))
    
    (define $bouton-ok-projet
      (make-object button%
        "Ok"
        $dialog-projet
        (lambda (x y)
          (send $dialog-projet show #f))))
    
    ; ======================
    ;     COMPTE PERSO
    
    (define $dialog-cp
      (make-object dialog% "Compte perso" #f 400 100 #f #f))
    
    (define $message-cp
      (make-object message%
        "Veuillez saisir vos chiffres et un compte :"
        $dialog-cp))
    
    (define $panel-horizontal-cp1 ; contient la liste des choix pour les chiffres
      (make-object horizontal-panel% $dialog-cp))
    
    (define $panel-horizontal-cp2 ; contient la liste des chiffres pour le compte
      (make-object horizontal-panel% $dialog-cp))
    
    (define $choix-chiffre1
      (make-object choice%
        ""
        '("1" "2" "3" "4" "5" "6" "7" "8" "9" "10" "25" "50" "75" "100")
        $panel-horizontal-cp1
        (lambda (c e)
          void)))
    
    (define $choix-chiffre2
      (make-object choice%
        ""
        '("1" "2" "3" "4" "5" "6" "7" "8" "9" "10" "25" "50" "75" "100")
        $panel-horizontal-cp1
        (lambda (c e)
          void)))
    
    (define $choix-chiffre3
      (make-object choice%
        ""
        '("1" "2" "3" "4" "5" "6" "7" "8" "9" "10" "25" "50" "75" "100")
        $panel-horizontal-cp1
        (lambda (c e)
          void)))
    
    (define $choix-chiffre4
      (make-object choice%
        ""
        '("1" "2" "3" "4" "5" "6" "7" "8" "9" "10" "25" "50" "75" "100")
        $panel-horizontal-cp1
        (lambda (c e)
          void)))
    
    (define $choix-chiffre5
      (make-object choice%
        ""
        '("1" "2" "3" "4" "5" "6" "7" "8" "9" "10" "25" "50" "75" "100")
        $panel-horizontal-cp1
        (lambda (c e)
          void)))
    
    (define $choix-chiffre6
      (make-object choice%
        ""
        '("1" "2" "3" "4" "5" "6" "7" "8" "9" "10" "25" "50" "75" "100")
        $panel-horizontal-cp1
        (lambda (c e)
          void)))
    
    (define $choix-cpt1
      (make-object choice%
        ""
        '("1" "2" "3" "4" "5" "6" "7" "8" "9")
        $panel-horizontal-cp2
        (lambda (c e)
          void)))
    
    (define $choix-cpt2
      (make-object choice%
        ""
        '("0" "1" "2" "3" "4" "5" "6" "7" "8" "9")
        $panel-horizontal-cp2
        (lambda (c e)
          void)))
    
    (define $choix-cpt3
      (make-object choice%
        ""
        '("0" "1" "2" "3" "4" "5" "6" "7" "8" "9")
        $panel-horizontal-cp2
        (lambda (c e)
          void)))
    
    (define $bouton-ok-cp
      (make-object button%
        "Ok"
        $dialog-cp
        (lambda (x y)
          (let ((ch1 (string->number (send $choix-chiffre1 get-string-selection)))
                (ch2 (string->number (send $choix-chiffre2 get-string-selection)))
                (ch3 (string->number (send $choix-chiffre3 get-string-selection)))
                (ch4 (string->number (send $choix-chiffre4 get-string-selection)))
                (ch5 (string->number (send $choix-chiffre5 get-string-selection)))
                (ch6 (string->number (send $choix-chiffre6 get-string-selection)))
                (cp1 (string->number (send $choix-cpt1 get-string-selection)))
                (cp2 (string->number (send $choix-cpt2 get-string-selection)))
                (cp3 (string->number (send $choix-cpt3 get-string-selection))))
            (set! tirage (list ch1 ch2 ch3 ch4 ch5 ch6))
            (set! cpt (list (list cp1 cp2 cp3) (+ (* cp1 100) (* cp2 10) cp3)))
            (init-sol)
            (effacer-chiffres)
            (effacer-compte)
            (afficher-chiffres tirage)
            (afficher-compte (car cpt) 2)
            (send $canvas on-paint)
            (send $canvas-compte on-paint)
            (send $dialog-cp show #f)))))
    
    ;   FIN COMPTE PERSO
    ; ======================
    
    ; la boite informations
    ; ======================
    (define $dialog-auteur
      (make-object dialog% "Infos sur les auteurs" #f 200 50 #f #f))
    
    ; les elements du menu
    ; ======================
    
    (define $item-fichier-projet
      (make-object menu-item%
        "Compte rendu du projet"
        $menu-fichier
        (lambda (x y)
          (send $dialog-projet show #t))))
    
    (define $item-fichier-infos
      (make-object menu-item%
        "Informations"
        $menu-fichier
        (lambda (x y)
          (send $dialog-auteur show #t))))
    
    (define $message-auteur0
      (make-object message%
        "ooOO=====-----------------=====OOoo"
        $dialog-auteur))
    
    (define $message-auteur1
      (make-object message%
        "Projet : Le compte est bon"
        $dialog-auteur))
    
    (define $message-auteur2
      (make-object message%
        "Nicolas RICHASSE - Julien BOIGONTIER"
        $dialog-auteur))
    
    (define $message-auteur3
      (make-object message%
        "Annee : 2001/2002, Deug MI2"
        $dialog-auteur))
    
    (define $message-auteur4
      (make-object message%
        "ooOO=====-----------------=====OOoo"
        $dialog-auteur))
    
    (define $bouton-ok-auteur
      (make-object button% "Ok" $dialog-auteur
        (lambda (x y)
          (send $dialog-auteur show #f))))
    
    (define $item-fichier-quitter
      (make-object menu-item%
        "Quitter"
        $menu-fichier
        (lambda (x y)
          (send $frame show #f))))
    
    ; les panneaux
    ; ======================
    (define $panel-horizontal0  ; contient les chiffres
      (make-object horizontal-panel% $frame))
    
    (define $panel-horizontal1  ; contient les chiffres
      (make-object horizontal-panel% $frame))
    
    (define $panel-horizontal2 ; contient la solution du compte
      (make-object horizontal-panel% $frame))
    
    (define $panel-vertical
      (make-object vertical-panel% $panel-horizontal2))
    
    (define $panel-horizontal3   ; contient le bouton Nouvelle partie
      (make-object horizontal-panel% $frame))
    
    (define $panel-horizontal4   ; contient les bouton Solution et Break
      (make-object horizontal-panel% $frame))
    
    ; images chiffres
    ; ======================
    (define $bitmap-canvas%
      (class canvas% (frame)
        (inherit get-dc)
        (override
          (on-paint (lambda () (send (get-dc) draw-bitmap $bitmap 7 1))))
        (sequence (super-init frame))))
    
    ; creation du canvas des chiffres
    (define $canvas
      (make-object $bitmap-canvas% $panel-horizontal0))
    
    ; creation du bitmap des chiffres
    (define $bitmap (make-object bitmap% 485 38))
    (define $bitmap-dc (make-object bitmap-dc%))
    
    ; ======================
    
    ; images compte
    ; ======================
    (define $bitmap-canvas%-compte
      (class canvas% (frame)
        (inherit get-dc)
        (override
          (on-paint (lambda () (send (get-dc) draw-bitmap $bitmap-compte 213 0))))
        (sequence (super-init frame))))
    
    ; creation du canvas des chiffres
    (define $canvas-compte
      (make-object $bitmap-canvas%-compte $panel-horizontal1))
    
    ; creation du bitmap des chiffres
    (define $bitmap-compte (make-object bitmap% 73 38))
    (define $bitmap-dc-compte (make-object bitmap-dc%))
    
    ; ======================
    
    (define $bouton-compte
      (make-object button% "Nouvelle partie" $panel-horizontal3
        (lambda (x y)
          (set! solution '())
          (set! arret #f)
          (effacer-chiffres)
          (effacer-compte)
          (go))
        ))
    
    (define $bouton-p
      (make-object button% "Compte perso" $panel-horizontal3
        (lambda (x y)
          (send $dialog-cp show #t))
        ))
    
    (define $bouton-solution
      (make-object button% "Solution !" $panel-horizontal4
        (lambda (x y)
          (init-sol)
          (set! arret #f)
          (set! solution (traiter (list->vector tirage) (cadr cpt)))
          (printf "Tirage : ~a~n Compte : ~a~n Solution : ~a~n" tirage (cadr cpt) solution)
          (send $solution set-label (string-append (arbre->infixe solution) " = " (number->string (cadr cpt)))))
        ))
    
    (define $bouton-break
      (make-object button% "BREAK !!" $panel-horizontal4
        (lambda (x y)
          (set! arret #t))
        ))
    
    (define (init-sol)
      (send $solution set-label "      Cliquez sur le bouton Solution pour lancer le calcul     "))
    
    (define $txt-solution
      (make-object message%
        "Solution :"
        $panel-vertical))
    
    (define $solution
      (make-object message%
        "      Cliquez sur le bouton Solution pour lancer le calcul     "
        $panel-vertical))
    
    (define (go)
      (init-sol)
      (send $frame show #t)
      (set! tirage (tirage-chiffres))
      (set! cpt (compte))
      (effacer-chiffres)
      (effacer-compte)
      (afficher-chiffres tirage)
      (afficher-compte (car cpt) 2)
      (send $canvas on-paint)
      (send $canvas-compte on-paint))
    
    
    ; __________________ FIN FRAME ____________________
    
    (define (evaluer A)
      (if (feuille? A)
          A
          (let ((vg (evaluer (fg A)))(vd (evaluer (fd A))))
            (case (racine A)
              ((+) (+ vg vd))
              ((-) (- vg vd))
              ((*) (* vg vd))
              ((/) (/ vg vd))
              (else (error "Evaluer : operateur inconnu !!" (racine A)))))))
    
    (define (vector-swap! i j v)
      (let ((l (vector-length v)))
        (cond [(or (> j l) (< i 0)) (error "vector-swap : erreur sur les indices " i j)]
              [(let ((temp (vector-ref v j)))
                 (vector-set! v j (vector-ref v i))
                 (vector-set! v i temp))])))
    
    (define (copy-vector v)
      (build-vector (vector-length v)
                    (lambda (x) (vector-ref v x))))
    
    (define (reste V i j)
      (let ((v (copy-vector V)))
        (cond ((or (and (= i 0) (= j 1))
                   (and (= j 0) (= i 1)))
               (build-vector (- (vector-length v) 2)
                             (lambda (x)
                               (vector-ref v (+ x 2)))))
              ((= i 0)
               (vector-swap! 1 j v)
               (build-vector (- (vector-length v) 2)
                             (lambda (x)
                               (vector-ref v (+ x 2)))))
              ((= i 1)
               (vector-swap! 0 j v)
               (build-vector (- (vector-length v) 2)
                             (lambda (x)
                               (vector-ref v (+ x 2)))))
              ((= j 1)
               (vector-swap! 0 i v)
               (build-vector (- (vector-length v) 2)
                             (lambda (x)
                               (vector-ref v (+ x 2)))))
              ((= j 0)
               (vector-swap! 1 i v)
               (build-vector (- (vector-length v) 2)
                             (lambda (x)
                               (vector-ref v (+ x 2)))))
              (else (vector-swap! 0 i v)
                    (vector-swap! 1 j v)
                    (build-vector (- (vector-length v) 2)
                                  (lambda (x)
                                    (vector-ref v (+ x 2))))))))
    
    (define (exploser V)
      (define (iter V position n acc)
        (if (= n position)
            acc
            (iter V
                  position
                  (modulo (+ n 1) (vector-length V))
                  (if (>= n position)
                      ; + - * /
                      (let* ((temp (reste V position n))
                             (v1 (vector-ref V position))
                             (v2 (vector-ref V n))
                             (vv1 (evaluer v1))
                             (vv2 (evaluer v2)))
                        (append (list (build-vector (- (vector-length V) 1)
                                                    (lambda (i)
                                                      (if (= i 0)
                                                          (cond [(= 0 vv1) (if (= 0 vv2) 0 v2)]
                                                                [(= 0 vv2) v1]
                                                                [else (arbre '+ v1 v2)])
                                                          (vector-ref temp (- i 1)))))
                                      (build-vector (- (vector-length V) 1)
                                                    (lambda (i)
                                                      (if (= i 0)
                                                          (cond [(= vv1 vv2) 0]
                                                                [(and (= 0 vv1) (= 0 vv2)) 0]
                                                                [else (arbre '- v1 v2)])
                                                          (vector-ref temp (- i 1)))))
                                      (build-vector (- (vector-length V) 1)
                                                    (lambda (i)
                                                      (if (= i 0)
                                                          (cond [(or (= 0 vv1) (= 0 vv2)) 0]
                                                                [(= 1 vv1) (if (= 1 vv2) 1 v2)]
                                                                [(= 1 vv2) v1]
                                                                [else (arbre '* v1 v2)])
                                                          (vector-ref temp (- i 1)))))
                                      (if (and (not (= 0 vv2)) (= 0 (modulo vv1 vv2)))
                                          (build-vector (- (vector-length V) 1)
                                                        (lambda (i)
                                                          (if (= i 0)
                                                              (cond [(= vv2 1) v1]
                                                                    [else (arbre '/ v1 v2)])
                                                              (vector-ref temp (- i 1)))))
                                          '()))
                                acc))
                      ; - /
                      (let* ((temp (reste V position n))
                             (v1 (vector-ref V position))
                             (v2 (vector-ref V n))
                             (vv1 (evaluer v1))
                             (vv2 (evaluer v2)))
                        (append (list (build-vector (- (vector-length V) 1)
                                                    (lambda (i)
                                                      (if (= i 0)
                                                          (cond [(= vv1 vv2) 0]
                                                                [(and (= 0 vv1) (= 0 vv2)) 0]
                                                                [else (arbre '- v1 v2)])
                                                          (vector-ref temp (- i 1)))))
                                      (if (and (not (= 0 vv2)) (= 0 (modulo vv1 vv2)))
                                          (build-vector (- (vector-length V) 1)
                                                        (lambda (i)
                                                          (if (= i 0)
                                                              (cond [(= vv2 1) v1]
                                                                    [else (arbre '/ v1 v2)])
                                                              (vector-ref temp (- i 1)))))
                                          '()))
                                acc))))))
      (let ((acc '()))
        (do ((i 0 (+ i 1)))
          ((= i (vector-length V)) acc)
          (set! acc (append (iter V i (modulo (+ i 1) (vector-length V)) '()) acc)))))
    
    (define (vnull? v)
      (or (null? v) (zero? (vector-length v))))
    
    (define (traiter V compte)
      (let ((sols '())(best '())(temp '()))
        (define (interne V)
          (cond [arret sols]
                [(null? temp) (vector-ref (car best) 0)]
                [else (cond [(vnull? V)
                             (if (null? (cdr temp))
                                 (vector-ref (car best) 0)
                                 (begin
                                   (set! temp (cdr temp))
                                   (interne (car temp))))]
                            [(= 1 (vector-length V)) (let* ((vc (evaluer (vector-ref V 0)))
                                                            (diff (abs (- compte vc))))
                                                       (cond [(= 0 diff) (set! sols (vector-ref V 0))
                                                              (set! arret #t)]
                                                             [(null? best) (set! best (cons V diff))]
                                                             [(< diff (cdr best)) (set! best (cons V diff))])
                                                       (if (null? (cdr temp))
                                                           (if arret
                                                               sols
                                                               (vector-ref (car best) 0))
                                                           (begin
                                                             (set! temp (cdr temp))
                                                             (interne (car temp)))
                                                           ))]
                            [else (let* ((vc (evaluer (vector-ref (car temp) 0)))
                                         (diff (abs (- compte vc))))
                                    (cond [(= 0 diff) (set! sols (vector-ref V 0))
                                           (set! arret #t)]
                                          [(null? best) (set! best (cons (make-vector 1 (vector-ref (car temp) 0)) diff))]
                                          [(< diff (cdr best)) (set! best (cons V diff))]))
                                  (set! temp (append (exploser V) (if (null? temp)
                                                                      '()
                                                                      (cdr temp))))
                                  (interne (car temp))])]))
        (set! temp (exploser V))
        (interne (car temp))
        ))
    
    (define (arbre->infixe A)
      (if (feuille? A)
          (number->string A)
          (let ((vg (arbre->infixe (fg A)))(vd (arbre->infixe (fd A))))
            (string-append "(" vg " " (symbol->string (racine A)) " " vd ")"))))
    
    (define couleur-noire (make-object color% 0 0 0))
    
    ; on associe le bitmap au dc
    (send $bitmap-dc set-bitmap $bitmap)
    (send $bitmap-dc-compte set-bitmap $bitmap-compte)
    ; on initialise le bitmap au vide
    (send $bitmap-dc clear)
    (send $bitmap-dc-compte clear)
    
    (send $canvas min-height 18)
    (send $canvas-compte min-height 18)
    
    (send $frame center)
    
    (send $dialog-auteur center)
    (send $dialog-projet center)
    (send $dialog-cp center)
    
    (send $projet-text load-file "projet.nfo" 'text #f)
    
    (send $bitmap-dc set-background couleur-noire)
    (send $bitmap-dc-compte set-background couleur-noire)
    
    (send $panel-horizontal0 set-alignment 'center 'center)
    (send $panel-horizontal1 set-alignment 'center 'center)
    (send $panel-horizontal2 set-alignment 'center 'center)
    (send $panel-horizontal3 set-alignment 'center 'center)
    (send $panel-horizontal4 set-alignment 'center 'center)
    
    (send $panel-horizontal-cp1 set-alignment 'center 'center)
    (send $panel-horizontal-cp2 set-alignment 'center 'center)
    
    (go)
    ))

(jouer)